/***************************************************************************************** 
*                                     TinyRtos51 
*                                The Real-Time Kernel 
*                              Copyright(c) 2024 fanxsp
*                         SPDX-License-Identifier: APACHE-2.0
*       This software is subject to an open source license and is distributed by fanxsp,
*       pursuant to the terms of the Apache License.
******************************************************************************************/
/***************************************************************************************** 
* 				TinyRtos51 port.h
* keilC 8051 port
* Author: fanxsp
* Revision: 1.00
* Date: 2023-08-24
* 
******************************************************************************************/
#include <intrins.h>

#ifdef SC92F854x
#include "portSC92F854x.h"
#endif

#ifdef STC8H
#include "portSTC8H.h"
#endif

/***************************************************************************************** 
* 进入和退出临界区 宏定义  
* 为了减少临界区对中断响应时间的影响，
* 可以只关闭和恢复有调用系统服务的中断
******************************************************************************************/
#define OSEnterCritical()   \
    do \
	{  \
		OSDi();   \
		OSEnterSum++; \
    } while(0)
                                        
#define OSExitCritical()    \
    do \
	{  \
		if(--OSEnterSum == 0) OSEi(); \
    } while (0) 


